using System;
using System.Collections.Generic;
using System.Text;

namespace DeltaCat.Net
{
	#region RMBException
	/// <summary>
	/// תԶ
	/// </summary>
	public class RMBException : System.Exception
	{
		/// <summary>
		/// Զ쳣
		/// </summary>
		/// <param name="msg"></param>
		public RMBException(string msg)
			: base(msg)
		{
		}
	}
	#endregion

	/// <summary>
    /// è DeltaCat
    /// http://www.zu14.cn/
	/// ʵֽҵʽתΪĸʽ֧9ס
	/// Դڻ
	/// </summary>
	public static class RMB
	{
		#region ڲ
		private static string RMBUppercase = "Ҽ½ƾ";
		private static string RMBUnitChar = "ԪʰǪʰǪʰǪʰǪʰǪʰǪ"; //λӦı־
		private const decimal MaxNumber = 9999999999999999999999999.99m;
		private const decimal MinNumber = -9999999999999999999999999.99m;
		private static char[] cDelim = { '.' }; //Сָʶ
		#endregion

		#region ڲ
		#region ConvertInt
		private static string ConvertInt(string intPart)
		{
			string buf = "";
			int length = intPart.Length;
			int curUnit = length;

			// λϵ
			string tmpValue = "";                    // ¼ǰֵʽ
			string tmpUnit = "";                    // ¼ǰֵӦĵλ
			int i;
			for (i = 0; i < length - 1; i++, curUnit--)
			{
				if (intPart[i] != '0')
				{
					tmpValue = DigToCC(intPart[i]);
					tmpUnit = GetUnit(curUnit - 1);
				}
				else
				{
					// ǰĵλ""Ҫ¼
					if ((curUnit - 1) % 4 == 0)
					{
						tmpValue = "";
						tmpUnit = GetUnit(curUnit - 1);//

					}
					else
					{
						tmpUnit = "";

						// ǰλ㣬ҪжһλǷΪ㣬ȷǷ¼''
						if (intPart[i + 1] != '0')
						{

							tmpValue = "";

						}
						else
						{
							tmpValue = "";
						}
					}
				}
				buf += tmpValue + tmpUnit;
			}


			// λ
			if (intPart[i] != '0')
				buf += DigToCC(intPart[i]);
			buf += "Ԫ";

			return CombinUnit(buf);
		}
		#endregion

		#region ConvertDecimal
		/// <summary>
		/// СֵĴ
		/// </summary>
		/// <param name="decPart">ҪС</param>
		/// <returns></returns>
		private static string ConvertDecimal(string decPart)
		{
			string buf = "";
			int i = decPart.Length;

			//СΪ
			if ((decPart == "0") || (decPart == "00"))
			{
				return "";
			}

			if (decPart.Length > 1) //2λ
			{
				if (decPart[0] == '0') //λΪ0.01
				{
					buf = DigToCC(decPart[1]) + ""; //ʱܷλΪ
				}
				else if (decPart[1] == '0')
				{
					buf = DigToCC(decPart[0]) + "";
				}
				else
				{
					buf = DigToCC(decPart[0]) + "";
					buf += DigToCC(decPart[1]) + "";
				}
			}
			else //1λ
			{
				buf += DigToCC(decPart[0]) + "";
			}
			return buf;
		}
		#endregion

		#region GetUnit
		/// <summary>
		/// ȡʽĶӦλõĵλ־
		/// </summary>
		/// <param name="n"></param>
		/// <returns></returns>
		private static string GetUnit(int n)
		{
			return RMBUnitChar[n].ToString();
		}
		#endregion

		#region DigToCC
		/// <summary>
		/// תΪӦַ ( Digital To Chinese Char )
		/// </summary>
		/// <param name="c">ַʽ洢</param>
		/// <returns></returns>
		private static string DigToCC(char c)
		{
			return RMBUppercase[c - '0'].ToString();
		}
		#endregion

		#region CheckNumberLimit
		private static void CheckNumberLimit(decimal number)
		{
			if ((number < MinNumber) || (number > MaxNumber))
			{
				throw new RMBException("תķΧ");
			}
		}
		#endregion

		#region CombinUnit
		/// <summary>
		/// ϲ
		/// </summary>
		/// <param name="rmb"></param>
		/// <returns></returns>
		private static string CombinUnit(string rmb)
		{
			if (rmb.Contains(""))
			{
				return rmb.Replace("", "");
			}
			if (rmb.Contains(""))
			{
				return rmb.Replace("", "");
			}
			if (rmb.Contains(""))
			{
				return rmb.Replace("", "");
			}
			return rmb;
		}
		#endregion
		#endregion

		#region Convert <decimal>
		/// <summary>
		/// תҴдʽ
		/// </summary>
		/// <param name="number"></param>
		/// <returns></returns>
		public static string Convert(decimal number)
		{
			bool NegativeFlag = false;
			decimal RMBNumber;

			CheckNumberLimit(number);

			RMBNumber = Math.Round(number, 2);    //ȡ2λС
			if (RMBNumber == 0)
			{
				return "Ԫ";
			}
			else if (RMBNumber < 0)  //Ǹ
			{
				NegativeFlag = true;
				RMBNumber = Math.Abs(RMBNumber);           //ȡֵ
			}
			else
			{
				NegativeFlag = false;
			}

			string buf = "";                           // ŷؽ
			string strDecPart = "";                    // СֵĴ
			string strIntPart = "";                    // ֵĴ
			string[] tmp = null;
			string strDigital = RMBNumber.ToString();

			tmp = strDigital.Split(cDelim, 2); // ݷΪС


			if (RMBNumber >= 1m) // 1ʱҪֵת
			{
				strIntPart = ConvertInt(tmp[0]);
			}

			if (tmp.Length > 1) //ֽС
			{
				strDecPart = ConvertDecimal(tmp[1]);
			}
			else  //ûС϶Ϊ
			{
				strDecPart = "";
			}

			if (NegativeFlag == false) //Ƿ
			{
				buf = strIntPart + strDecPart;
			}
			else
			{
				buf = "" + strIntPart + strDecPart;
			}
			return buf;
		}

        public static string Convert(double number)
        {
            return Convert((decimal)number);
        }
		#endregion
	}
}
